<%@ WebHandler Language="C#" Class="download" %>

using System;
using System.Web;
using System.IO;
using System.Data;
using System.Data.SqlClient;

public class download : IHttpHandler {

	HttpContext context;
    
    public void ProcessRequest (HttpContext context) {

		this.context = context;

		string file=context.Request.QueryString["file"];
		if (string.IsNullOrEmpty(file))
		{
			Error404();
			return; 
		}

		if (!file.StartsWith("/"))
		{
			Error404();
			return; 
		}

		if (file.Contains(".."))
		{
			Error404();
			return; 
		}

		DateTime dt;
		string filename;
		int filesize;
		byte[] filedata;

		using (SqlConnection conn = new SqlConnection(SqlFileProvider.ConnectionString))
		{
			conn.Open();

			using (SqlCommand cmd = new SqlCommand("select * from fsitems where path=@p0", conn))
			{
				cmd.Parameters.Add("@p0",SqlDbType.NVarChar,300).Value=file;

				using (SqlDataReader reader = cmd.ExecuteReader())
				{
					if (!reader.Read())
					{
						Error404();
						return;
					}

					dt = reader.GetDateTime(reader.GetOrdinal("createdt"));
					filename = reader.GetString(reader.GetOrdinal("filename"));
					filesize = reader.GetInt32(reader.GetOrdinal("filesize"));
					filedata = (byte[])reader["filedata"];
				}
			}
		}


		context.Response.ClearHeaders();
		context.Response.AddHeader("Content-Length", filesize.ToString());
		context.Response.BinaryWrite(filedata);
    }

	void Error404()
	{
		context.Response.Status = "404 (Not Found)";
		context.Response.Write("404 (Not Found)");
	}
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}